/*
 * Copyright (c) 2002 - trem0r
 * This file is part of the PornView - photo collection manager.
 */

#ifndef __GTK_MPLAYER_H__
#define __GTK_MPLAYER_H__

#include <stdlib.h>
#include <gtk/gtk.h>
#include <gdk/gdkx.h>

#ifdef __cplusplus
extern          "C"
{
#endif				/* __cplusplus */

    typedef struct _GtkMPlayer GtkMPlayer;

    struct _GtkMPlayer
    {
	GtkWidget      *widget;	/*the integrable widget */
	GtkWidget      *mySocket;	/*the socket (internal) */
	gchar          *file;	/*filename (internal */
	guint32         xid;	/*X window handle (internal) */
	int             width;	/*widget's width */
	int             height;	/*widget's height */
	gboolean        ready;	/*is the player ready (internal) */
	int             childpid;	/*mplayer's pid (internal) */
	guint           timer;	/*timer (internal) */
    };

/* create player */
    GtkMPlayer     *gtk_mplayer_new (gchar * file);
/*get integrable widget */
    GtkWidget      *gtk_mplayer_get_widget (GtkMPlayer * player);
/*init player */
    void            gtk_mplayer_init (GtkMPlayer * player);
/* show player */
    void            gtk_mplayer_show (GtkMPlayer * player);
/* start player */
    void            gtk_mplayer_start (GtkMPlayer * player);
/* stop player */
    void            gtk_mplayer_stop (GtkMPlayer * player);
/* change played file */
    void            gtk_mplayer_open_file (GtkMPlayer * player, gchar * file);
/* check if player runs */
    gboolean        gtk_mplayer_is_running (GtkMPlayer * player);

#ifdef __cplusplus
}
#endif				/* __cplusplus */

#endif	/* __GTK_MPLAYER_H__ */
